<?php
/*                                                       */
/* send_automail.php - Mail for reservation auto-info    */
/* $ID 185i - 2023-12-28 - brom $                        */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de> */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it  */
/* under the terms the BROM CMS/BelCal license for free */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2008  (kontakt@brom-belcal.de)    */
/*                                                       */

// Direct access prevention
defined('BC_PATH') OR die(header('Location: ../index.php'));

require_once(BC_PATH.'/lib/classes/class.admin.php');
$admin = new admin('Start','start','system',false,false);
require_once(BC_PATH.'/lib/functions.php');
$file_path = BC_PATH.'/temp/attachfiles/';
@make_dir($file_path);

// Get language from calendar
if(!file_exists(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php')) {
  // no module language file exists for the language set by the user, include default module language file EN.php
  require(BC_PATH .'/modules/calendar/languages/EN.php');
}
else {
  // a module language file exists for the language defined by the user, load it
  require(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php');
}
if(file_exists(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php')) {
  require(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php');
}
// Get the objects to send the automail
$forsend = array();
$protocol = '';
$doc_date = convert_date(DATE_FORMAT,time());
$protocol_subject = $CALTEXT['EMAIL_TPL_7'].' '.$TEXT['FROM'].' '.$doc_date;
$get_obj_to_send = $datapdo->query("SELECT `object_id`,`days_before`,`addsubject`,`bodycontent`,`confirm_read` FROM `".TABLE_PREFIX."res_templates` WHERE `subject`='7' AND `send_autoinfo`='1' AND `language`='".LANGUAGE."' ORDER BY `object_id` ASC");
if($datapdo->numRows($get_obj_to_send)>0){
  while($obj_to_send = $datapdo->fetchRow($get_obj_to_send,false)){
    $o_id=$obj_to_send['object_id'];
    $days_before = $obj_to_send['days_before']+1;
    $chk_start = time()+($days_before*86400);
    $get_res = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."reservations` WHERE `object_id`='$o_id' AND `res_start`>'".time()."' AND `res_start`<='$chk_start' AND `mail`!='' AND `status`='3'");
    if($datapdo->numRows($get_res)>0){
      $forsend[$o_id] = $obj_to_send;
      $forsend[$o_id]['res'] = array();
      while($res = $datapdo->fetchRow($get_res,false)){
        $r_id = $res['res_id'];
        // Check first an automail is allready send this reservation
        if($datapdo->numRows($datapdo->query("SELECT `rfile_id` FROM `".TABLE_PREFIX."res_files` WHERE `tpl`='7' AND `res_id`='$r_id'"))>0){ continue 1; }
        $forsend[$o_id]['res'][$r_id] = $res;
      }
    }
  }
}
if(count($forsend) > 0){
  $body_vars = array('[DOC_DATE]','[OWNER_ADDRESS]','[OWNER_NAME]','[ADR_TITLE]','[ADR_NAME]','[OBJECT_TITLE]',
		    '[SFLD-0A]','[SFLD-1A]','[SFLD-2A]','[SFLD-3A]','[SFLD-4A]','[SFLD-5A]','[SFLD-6A]','[SFLD-7A]','[SFLD-8A]','[SFLD-9A]',
		    '[SFLD-0L]','[SFLD-1L]','[SFLD-2L]','[SFLD-3L]','[SFLD-4L]','[SFLD-5L]','[SFLD-6L]','[SFLD-7L]','[SFLD-8L]','[SFLD-9L]',
		    '[SFLD-0F]','[SFLD-1F]','[SFLD-2F]','[SFLD-3F]','[SFLD-4F]','[SFLD-5F]','[SFLD-6F]','[SFLD-7F]','[SFLD-8F]','[SFLD-9F]',
		    '[RES_NUMBER]','[DATE_START]','[TIME_START]','[DATE_END]','[TIME_END]');
  $subject_vars = array('[RES_NUMBER]','[OBJECT_TITLE]','[DATE_START]','[DATE_END]','[TIME_START]','[TIME_END]','[DOC_DATE]');
  foreach($forsend AS $oId => $oVal){
    if(count($oVal['res']) > 0){
      // Get the template and attachments this object
      $bodycontent = $oVal['bodycontent'];
      $subject_content = $oVal['addsubject'];
      $confirm_read = ($oVal['confirm_read']==1?true:false);
      $attach = array();
      $attach_ids = '';
      $get_defattach = $datapdo->query("SELECT `attachment_id`,`filename`,`attach` FROM `".TABLE_PREFIX."res_attachments` WHERE `object_id`='$oId' AND `tpl`='7'");
      if($datapdo->numRows($get_defattach)>0){
        while($defattach = $datapdo->fetchRow($get_defattach)){
          $filename = $defattach['filename'];
          $attach_file = $file_path.$defattach['filename'];
          $file_content = base64_decode($defattach['attach']);
          $handle = fopen($attach_file, 'wb');
          fwrite($handle, $file_content);
          fclose($handle);
          $attach[] = array($attach_file,$filename);
          $attach_ids .= ($attach_ids!=''?'|':'').$defattach['attachment_id'];
        }
      }
      $object_title = get_object_title($oId,LANGUAGE);
      $protocol .= '<p><b>'.$object_title.':</b></p>';
      $owner = $datapdo->get_one("SELECT `owner` FROM `".TABLE_PREFIX."objects` WHERE `object_id`='$oId' LIMIT 1");
      if($owner > 1){
        $adr_id = $datapdo->get_one("SELECT `address_id` FROM `".TABLE_PREFIX."address` WHERE `user_id`='$owner' LIMIT 1");
        $owner_address = $admin->get_adr_complate($adr_id);
        $owner_company = $admin->get_company($adr_id);
        $owner_prename = $admin->get_adr_prename($adr_id);
        $mail_from = $admin->get_email($adr_id);
        $owner_name = ($owner_company!=''?$owner_company.', ':'').($owner_prename!=''?$owner_prename.' ':'').$admin->get_adr_name($owner);
      }
      else{
        $owner_address = '';
        $owner_name = $admin->get_display_name(1);
        $mail_from = $datapdo->get_one("SELECT `email` FROM `".TABLE_PREFIX."users` WHERE `user_id`='1' LIMIT 1");
      }
      // Get service fields
      $service_fields = array();
      $get_services = $datapdo->query("SELECT `slabel_id`,`freeflds`,`saddr_id` FROM `".TABLE_PREFIX."cal_services` WHERE `object_id`='$oId' AND `saddr_id`>'0'");
      if($datapdo->numRows($get_services)>0){
        while($services = $datapdo->fetchRow($get_services,false)){
          $slabid = $services['slabel_id'];
          $sfflds_array = unserialize($services['freeflds']);
          $sffld = $sfflds_array[LANGUAGE];
          $adrid = $services['saddr_id'];
          $sadr_company = $admin->get_company($adrid);
          $sadr_name = $admin->get_adr_name($adrid);
          $sadr_phone = $admin->get_phone($adrid);
          $sadr = ($sadr_company!=''?$sadr_company:$sadr_name).($sadr_phone!=''?' ('.$sadr_phone.')':'');
          $get_slabel_array = $datapdo->get_one("SELECT `labels` FROM `".TABLE_PREFIX."cal_servicelabels` WHERE `slabel_id`='$slabid' LIMIT 1");
          $slabels = unserialize($get_slabel_array);
          $slabel = $slabels[LANGUAGE];
          $service_fields[] = array('l'=>$slabel,'a'=>$sadr,'f'=>$sffld);
        }
      }
      foreach($oVal['res'] AS $rId => $rVal){
        $res_number = $admin->zero_to_number($rId);
        $date_start = convert_date(DATE_FORMAT,$rVal['res_start']);
        $time_start = date(TIME_FORMAT,$rVal['res_start']);
        $date_end = convert_date(DATE_FORMAT,$rVal['res_end']);
        $time_end = date(TIME_FORMAT,$rVal['res_end']);
        $aId = $datapdo->get_one("SELECT `address_id` FROM `".TABLE_PREFIX."address` WHERE `client_id`='".$rVal['client_id']."' LIMIT 1");
//        $aId = $rVal['address_id'];
        $adr_title = $admin->get_adr_title($aId);
        $getadr_name = $admin->get_adr_name($aId);
        $getadr_prename = $admin->get_adr_prename($aId);
        $adr_name = ($getadr_prename!=''?$getadr_prename.' ':'').$getadr_name;
        $sId = $rVal['section_id'];
        $get_mail_to = $datapdo->query("SELECT `email` FROM `".TABLE_PREFIX."res_files` WHERE `tpl`='1' AND `res_id`='$rId' AND `email`!='' ORDER BY `savedate` DESC LIMIT 0,1");
        $mail_to = $rVal['mail'];
        if($datapdo->numRows($get_mail_to)>0){
          $filemail_to = $datapdo->fetchRow($get_mail_to,false);
          $mail_to = $filemail_to['email'];
        }
        if($mail_to!='' AND $admin->validate_email($mail_to)==true){
          $subject_values = array($res_number,$object_title,$date_start,$date_end,$time_start,$time_end,$doc_date);
          $subject = str_replace($subject_vars,$subject_values,$subject_content);
          for($si=0; $si<10; $si++){
            $inSFLDa = 'sfld_'.$si.'a';
            $inSFLDl = 'sfld_'.$si.'l';
            $inSFLDf = 'sfld_'.$si.'f';
            if(isset($service_fields[$si]) AND $service_fields[$si]['a']!=''){
              $$inSFLDa = $service_fields[$si]['a'];
              $$inSFLDl = $service_fields[$si]['l'];
              $$inSFLDf = $service_fields[$si]['f'];
            }
            else{
              $$inSFLDa = '';
              $$inSFLDl = '';
              $$inSFLDf = '';
            }
          }
          $body_values = array($doc_date,$owner_address,$owner_name,$adr_title,$adr_name,$object_title,
	      $sfld_0a,$sfld_1a,$sfld_2a,$sfld_3a,$sfld_4a,$sfld_5a,$sfld_6a,$sfld_7a,$sfld_8a,$sfld_9a,
	      $sfld_0l,$sfld_1l,$sfld_2l,$sfld_3l,$sfld_4l,$sfld_5l,$sfld_6l,$sfld_7l,$sfld_8l,$sfld_9l,
	      $sfld_0f,$sfld_1f,$sfld_2f,$sfld_3f,$sfld_4f,$sfld_5f,$sfld_6f,$sfld_7f,$sfld_8f,$sfld_9f,
	      $res_number,$date_start,$time_start,$date_end,$time_end);
          $mail_body = str_replace($body_vars,$body_values,$bodycontent);
          // Send the mail and save it
          $get_mbox = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."mailboxes` WHERE `user_id`='1' ORDER BY `mailbox_id` LIMIT 0,1");
          if($datapdo->numRows($get_mbox)>0){
            $saveresult = true;
            $box = $datapdo->fetchRow($get_mbox);
            $mailbox = $box['position']-1;
            $confirm_mail = $box['sendermail'];
            $pass = $admin->get_cryption($box['password'],$box['imapuser'],true);
            require_once(BC_PATH.'/lib/classes/class.imap.php');
            $imap = new imap($box['imapserver'],$box['imapport'],$box['imapuser'],$pass,$box['imaptype'],$box['sentfolder']);
            if(!$imap){ $saveresult = false; }
          }
          else{ $saveresult = false; }
          $send_success = $admin->mail($mail_from,$mail_to,$subject,$mail_body,$owner_name,'HTML',$attach,$saveresult,$confirm_mail);
          $protocol .= '<table>';
          $protocol_link = '<a href="'.BC_DOMAIN.ADMIN_URL.'/reservations/res_modify.php?object_id='.$oId.ARGSO.'section_id='.$sId.ARGSO.'res_id='.$rId.'">';
          if($send_success != false){
            if($saveresult == true){
              $insent = $imap->saveMailMsgInSent($send_success);
              $imap = NULL;
            }
            // Now save the doc to sended files
            $datapdo->query("INSERT INTO `".TABLE_PREFIX."res_files` "
	         . "(`object_id`,`section_id`,`res_id`,`address_id`,`email`,`title`,`content`,`tpl`,`attachments`,`author`,`savedate`,`bil_number`,`canceled`) VALUES "
	         . "('$oId','$sId','$rId','$aId','$mail_to','$subject','$mail_body','7','$attach_ids','$owner_name','".time()."','','0')");
            $protocol .= '<tr><td>'.$protocol_link.$TEXT['RESERVATION'].' ('.$res_number.') - '.$object_title.'</a></td><td>'.$date_start.' - '.$date_end.'</td><td>'.$TEXT['MAIL_TO'].' '.$mail_to.' '.$TEXT['SENDED'].'</td></tr>';
          }
          else {
            // Save the error on send
            $protocol .= '<tr><td>'.$protocol_link.$TEXT['RESERVATION'].' ('.$res_number.') - '.$object_title.'</a></td><td>'.$date_start.' - '.$date_end.'</td><td>'.$TEXT['MAIL_TO'].' '.$mail_to.' <b>'.$TEXT['ERROR'].'</b></td></tr>';
          }
          $protocol .= '</table>';
        }
      }
    }
  }
}
// Send the protocol to admin
if($protocol != ''){
  $protocol_subject = entities_to_umlauts($CALTEXT['EMAIL_TPL_7'].' - '.$CALTEXT['PROTOCOL']);
  $protocol_name = $admin->get_display_name(1);
  $protocolmail_to = $datapdo->get_one("SELECT `email` FROM `".TABLE_PREFIX."users` WHERE `user_id`='1' LIMIT 1");
  $protocolmail_from = SERVER_EMAIL;
  $proto_success = $admin->mail($protocolmail_from,$protocolmail_to,$protocol_subject,$protocol,$protocol_name,'HTML');
}
$admin = NULL;
?>